"use strict";
/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodePushDeploymentMetricsImpl = void 0;
const coreClient = require("@azure/core-client");
const Mappers = require("../models/mappers");
const Parameters = require("../models/parameters");
/** Class containing CodePushDeploymentMetrics operations. */
class CodePushDeploymentMetricsImpl {
    /**
     * Initialize a new instance of the class CodePushDeploymentMetrics class.
     * @param client Reference to the service client
     */
    constructor(client) {
        this.client = client;
    }
    /**
     * Gets all releases metrics for specified Deployment
     * @param deploymentName deployment name
     * @param ownerName The name of the owner
     * @param appName The name of the application
     * @param options The options parameters.
     */
    get(deploymentName, ownerName, appName, options) {
        return this.client.sendOperationRequest({ deploymentName, ownerName, appName, options }, getOperationSpec);
    }
}
exports.CodePushDeploymentMetricsImpl = CodePushDeploymentMetricsImpl;
// Operation Specifications
const serializer = coreClient.createSerializer(Mappers, /* isXml */ false);
const getOperationSpec = {
    path: "/v0.1/apps/{owner_name}/{app_name}/deployments/{deployment_name}/metrics",
    httpMethod: "GET",
    responses: {
        200: {
            bodyMapper: {
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Paths1Fpy0IjV01AppsOwnerNameAppNameDeploymentsDeploymentNameMetricsGetResponses200ContentApplicationJsonSchemaItems"
                        }
                    }
                }
            }
        },
        default: {
            bodyMapper: Mappers.Paths1U65Jj1V01AppsOwnerNameAppNameDeploymentsDeploymentNameMetricsGetResponsesDefaultContentApplicationJsonSchema
        }
    },
    urlParameters: [
        Parameters.$host,
        Parameters.ownerName,
        Parameters.appName,
        Parameters.deploymentName
    ],
    headerParameters: [Parameters.accept],
    serializer
};
