"use strict";
/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.DistributionGroupInvitationsImpl = void 0;
const coreClient = require("@azure/core-client");
const Mappers = require("../models/mappers");
const Parameters = require("../models/parameters");
/** Class containing DistributionGroupInvitations operations. */
class DistributionGroupInvitationsImpl {
    /**
     * Initialize a new instance of the class DistributionGroupInvitations class.
     * @param client Reference to the service client
     */
    constructor(client) {
        this.client = client;
    }
    /**
     * Accepts all pending invitations to distribution groups for the specified user
     * @param options The options parameters.
     */
    acceptAll(options) {
        return this.client.sendOperationRequest({ options }, acceptAllOperationSpec);
    }
}
exports.DistributionGroupInvitationsImpl = DistributionGroupInvitationsImpl;
// Operation Specifications
const serializer = coreClient.createSerializer(Mappers, /* isXml */ false);
const acceptAllOperationSpec = {
    path: "/v0.1/user/invitations/distribution_groups/accept",
    httpMethod: "POST",
    responses: {
        204: {},
        default: {
            bodyMapper: Mappers.Paths8ZdnzsV01UserInvitationsDistributionGroupsAcceptPostResponsesDefaultContentApplicationJsonSchema
        }
    },
    urlParameters: [Parameters.$host],
    headerParameters: [Parameters.accept],
    serializer
};
