"use strict";
/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.SharedconnectionImpl = void 0;
const coreClient = require("@azure/core-client");
const Mappers = require("../models/mappers");
const Parameters = require("../models/parameters");
/** Class containing Sharedconnection operations. */
class SharedconnectionImpl {
    /**
     * Initialize a new instance of the class Sharedconnection class.
     * @param client Reference to the service client
     */
    constructor(client) {
        this.client = client;
    }
    /**
     * Gets all service connections of the service type for GDPR export.
     * @param options The options parameters.
     */
    connections(options) {
        return this.client.sendOperationRequest({ options }, connectionsOperationSpec);
    }
}
exports.SharedconnectionImpl = SharedconnectionImpl;
// Operation Specifications
const serializer = coreClient.createSerializer(Mappers, /* isXml */ false);
const connectionsOperationSpec = {
    path: "/v0.1/user/export/serviceConnections",
    httpMethod: "GET",
    responses: {
        200: {
            bodyMapper: {
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Get200ApplicationJsonItemsItem"
                        }
                    }
                }
            }
        },
        default: {
            bodyMapper: Mappers.PathsIs7Fv3V01UserExportServiceconnectionsGetResponsesDefaultContentApplicationJsonSchema
        }
    },
    urlParameters: [Parameters.$host],
    headerParameters: [Parameters.accept],
    serializer
};
