"use strict";
/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoreReleasePublishLogsImpl = void 0;
const coreClient = require("@azure/core-client");
const Mappers = require("../models/mappers");
const Parameters = require("../models/parameters");
/** Class containing StoreReleasePublishLogs operations. */
class StoreReleasePublishLogsImpl {
    /**
     * Initialize a new instance of the class StoreReleasePublishLogs class.
     * @param client Reference to the service client
     */
    constructor(client) {
        this.client = client;
    }
    /**
     * Returns publish logs for a particular release published to a particular store
     * @param storeName The name of the store
     * @param releaseId The ID of the realease
     * @param ownerName The name of the owner
     * @param appName The name of the application
     * @param options The options parameters.
     */
    get(storeName, releaseId, ownerName, appName, options) {
        return this.client.sendOperationRequest({ storeName, releaseId, ownerName, appName, options }, getOperationSpec);
    }
}
exports.StoreReleasePublishLogsImpl = StoreReleasePublishLogsImpl;
// Operation Specifications
const serializer = coreClient.createSerializer(Mappers, /* isXml */ false);
const getOperationSpec = {
    path: "/v0.1/apps/{owner_name}/{app_name}/distribution_stores/{store_name}/releases/{release_id}/publish_logs",
    httpMethod: "GET",
    responses: {
        200: {},
        default: {
            bodyMapper: Mappers.PathsEm3U11V01AppsOwnerNameAppNameDistributionStoresStoreNameReleasesReleaseIdPublishLogsGetResponsesDefaultContentApplicationJsonSchema
        }
    },
    urlParameters: [
        Parameters.$host,
        Parameters.releaseId,
        Parameters.ownerName,
        Parameters.appName,
        Parameters.storeName
    ],
    headerParameters: [Parameters.accept],
    serializer
};
