"use strict";
/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebhooksImpl = void 0;
const coreClient = require("@azure/core-client");
const Mappers = require("../models/mappers");
const Parameters = require("../models/parameters");
/** Class containing Webhooks operations. */
class WebhooksImpl {
    /**
     * Initialize a new instance of the class Webhooks class.
     * @param client Reference to the service client
     */
    constructor(client) {
        this.client = client;
    }
    /**
     * Get web hooks configured for a particular app
     * @param ownerName The name of the owner
     * @param appName The name of the application
     * @param options The options parameters.
     */
    list(ownerName, appName, options) {
        return this.client.sendOperationRequest({ ownerName, appName, options }, listOperationSpec);
    }
}
exports.WebhooksImpl = WebhooksImpl;
// Operation Specifications
const serializer = coreClient.createSerializer(Mappers, /* isXml */ false);
const listOperationSpec = {
    path: "/v0.1/apps/{owner_name}/{app_name}/webhooks",
    httpMethod: "GET",
    responses: {
        200: {
            bodyMapper: Mappers.PathsQn2DimV01AppsOwnerNameAppNameWebhooksGetResponses200ContentApplicationJsonSchema
        },
        default: {
            bodyMapper: Mappers.PathsYzqp66V01AppsOwnerNameAppNameWebhooksGetResponsesDefaultContentApplicationJsonSchema
        }
    },
    urlParameters: [Parameters.$host, Parameters.ownerName, Parameters.appName],
    headerParameters: [Parameters.accept],
    serializer
};
