/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */

import {
  AppleMappingTestFlightGroupsOptionalParams,
  AppleMappingTestFlightGroupsResponse,
  AppleMappingGetOptionalParams,
  AppleMappingGetResponse,
  AppleMappingDeleteOptionalParams,
  Paths1B7RevxV01AppsOwnerNameAppNameAppleMappingPostRequestbodyContentApplicationJsonSchema,
  AppleMappingCreateOptionalParams,
  AppleMappingCreateResponse
} from "../models";

/** Interface representing a AppleMapping. */
export interface AppleMapping {
  /**
   * Fetch all apple test flight groups
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  testFlightGroups(
    ownerName: string,
    appName: string,
    options?: AppleMappingTestFlightGroupsOptionalParams
  ): Promise<AppleMappingTestFlightGroupsResponse>;
  /**
   * Get mapping of apple app to an existing app in apple store.
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  get(
    ownerName: string,
    appName: string,
    options?: AppleMappingGetOptionalParams
  ): Promise<AppleMappingGetResponse>;
  /**
   * Delete mapping of apple app to an existing app in apple store.
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  delete(
    ownerName: string,
    appName: string,
    options?: AppleMappingDeleteOptionalParams
  ): Promise<void>;
  /**
   * Create a mapping for an existing app in apple store for the specified application.
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param body The apple app mapping object
   * @param options The options parameters.
   */
  create(
    ownerName: string,
    appName: string,
    body: Paths1B7RevxV01AppsOwnerNameAppNameAppleMappingPostRequestbodyContentApplicationJsonSchema,
    options?: AppleMappingCreateOptionalParams
  ): Promise<AppleMappingCreateResponse>;
}
