/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */

import {
  BillingAggregatedInformationGetForOrgOptionalParams,
  BillingAggregatedInformationGetForOrgResponse,
  BillingAggregatedInformationGetAllOptionalParams,
  BillingAggregatedInformationGetAllResponse,
  BillingAggregatedInformationGetByAppOptionalParams,
  BillingAggregatedInformationGetByAppResponse
} from "../models";

/** Interface representing a BillingAggregatedInformation. */
export interface BillingAggregatedInformation {
  /**
   * Aggregated Billing Information for a given Organization.
   * @param orgName The name of the Organization
   * @param options The options parameters.
   */
  getForOrg(
    orgName: string,
    options?: BillingAggregatedInformationGetForOrgOptionalParams
  ): Promise<BillingAggregatedInformationGetForOrgResponse>;
  /**
   * Aggregated Billing Information for the requesting user and the organizations in which the user is an
   * admin.
   * @param options The options parameters.
   */
  getAll(
    options?: BillingAggregatedInformationGetAllOptionalParams
  ): Promise<BillingAggregatedInformationGetAllResponse>;
  /**
   * Aggregated Billing Information for owner of a given app.
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  getByApp(
    ownerName: string,
    appName: string,
    options?: BillingAggregatedInformationGetByAppOptionalParams
  ): Promise<BillingAggregatedInformationGetByAppResponse>;
}
