/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */

import {
  BugTrackerGetRepoIssueFromCrashOptionalParams,
  BugTrackerGetRepoIssueFromCrashResponse,
  BugTrackerGetSettingsOptionalParams,
  BugTrackerGetSettingsResponse
} from "../models";

/** Interface representing a BugTracker. */
export interface BugTracker {
  /**
   * Get project issue related to a crash group
   * @param crashGroupId CrashGroup Id
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  getRepoIssueFromCrash(
    crashGroupId: string,
    ownerName: string,
    appName: string,
    options?: BugTrackerGetRepoIssueFromCrashOptionalParams
  ): Promise<BugTrackerGetRepoIssueFromCrashResponse>;
  /**
   * Get bug tracker settings for a particular app
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  getSettings(
    ownerName: string,
    appName: string,
    options?: BugTrackerGetSettingsOptionalParams
  ): Promise<BugTrackerGetSettingsResponse>;
}
