/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */

import {
  CodePushDeploymentReleasesDeleteOptionalParams,
  CodePushDeploymentReleasesGetOptionalParams,
  CodePushDeploymentReleasesGetResponse,
  Paths1Q5DgwjV01AppsOwnerNameAppNameDeploymentsDeploymentNameReleasesPostRequestbodyContentApplicationJsonSchema,
  CodePushDeploymentReleasesCreateOptionalParams,
  CodePushDeploymentReleasesCreateResponse
} from "../models";

/** Interface representing a CodePushDeploymentReleases. */
export interface CodePushDeploymentReleases {
  /**
   * Clears a Deployment of releases
   * @param deploymentName deployment name
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  delete(
    deploymentName: string,
    ownerName: string,
    appName: string,
    options?: CodePushDeploymentReleasesDeleteOptionalParams
  ): Promise<void>;
  /**
   * Gets the history of releases on a Deployment
   * @param deploymentName deployment name
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  get(
    deploymentName: string,
    ownerName: string,
    appName: string,
    options?: CodePushDeploymentReleasesGetOptionalParams
  ): Promise<CodePushDeploymentReleasesGetResponse>;
  /**
   * Create a new CodePush release for the specified deployment
   * @param deploymentName deployment name
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param uploadedRelease The necessary information required to download the bundle and being the
   *                        release process.
   * @param options The options parameters.
   */
  create(
    deploymentName: string,
    ownerName: string,
    appName: string,
    uploadedRelease: Paths1Q5DgwjV01AppsOwnerNameAppNameDeploymentsDeploymentNameReleasesPostRequestbodyContentApplicationJsonSchema,
    options?: CodePushDeploymentReleasesCreateOptionalParams
  ): Promise<CodePushDeploymentReleasesCreateResponse>;
}
