/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */

import {
  CrashGroupsGetStacktraceOptionalParams,
  CrashGroupsGetStacktraceResponse,
  CrashGroupsGetOptionalParams,
  CrashGroupsGetResponse,
  CrashGroupsUpdateOptionalParams,
  CrashGroupsUpdateResponse,
  CrashGroupsListOptionalParams,
  CrashGroupsListResponse
} from "../models";

/** Interface representing a CrashGroups. */
export interface CrashGroups {
  /**
   * Gets a stacktrace for a specific crash.
   * @param crashGroupId id of a specific group
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  getStacktrace(
    crashGroupId: string,
    ownerName: string,
    appName: string,
    options?: CrashGroupsGetStacktraceOptionalParams
  ): Promise<CrashGroupsGetStacktraceResponse>;
  /**
   * Gets a specific group.
   * @param crashGroupId id of a specific group
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  get(
    crashGroupId: string,
    ownerName: string,
    appName: string,
    options?: CrashGroupsGetOptionalParams
  ): Promise<CrashGroupsGetResponse>;
  /**
   * Updates a group.
   * @param crashGroupId id of a specific group
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  update(
    crashGroupId: string,
    ownerName: string,
    appName: string,
    options?: CrashGroupsUpdateOptionalParams
  ): Promise<CrashGroupsUpdateResponse>;
  /**
   * Gets a list of crash groups and whether the list contains all available groups.
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  list(
    ownerName: string,
    appName: string,
    options?: CrashGroupsListOptionalParams
  ): Promise<CrashGroupsListResponse>;
}
