/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */

import {
  NotificationsGetUserEmailSettingsOptionalParams,
  NotificationsGetUserEmailSettingsResponse,
  NotificationsGetAppEmailSettingsOptionalParams,
  NotificationsGetAppEmailSettingsResponse
} from "../models";

/** Interface representing a Notifications. */
export interface Notifications {
  /**
   * Get Default email notification settings for the user
   * @param options The options parameters.
   */
  getUserEmailSettings(
    options?: NotificationsGetUserEmailSettingsOptionalParams
  ): Promise<NotificationsGetUserEmailSettingsResponse>;
  /**
   * Get Email notification settings of user for a particular app
   * @param ownerName The name of the owner
   * @param appName The name of the application
   * @param options The options parameters.
   */
  getAppEmailSettings(
    ownerName: string,
    appName: string,
    options?: NotificationsGetAppEmailSettingsOptionalParams
  ): Promise<NotificationsGetAppEmailSettingsResponse>;
}
